//uniform... von OpenGL...
uniform sampler1D sTransfer;
uniform sampler2D sBackFace;
uniform sampler3D volume_tex;
uniform sampler3D sPartiel;
uniform vec3 sSliding;
uniform int IsMode;
uniform float sSlideValue;
uniform int adaptiv;
uniform int sMaxIntensity;
uniform int sPreshading;

//varying... von Vertex Shader
varying vec4 hposition;
varying vec4 position;
varying mat4 sAdaptivPlane;

//globlae variable
bool preprocessing = true; //Preprocessing wohl ned ganz ok?

vec3 readTexture(vec3 pos)
{
	if(pos.x > 1.0) pos.x = 1.0;
	if(pos.y > 1.0) pos.y = 1.0;
	if(pos.z > 1.0) pos.z = 1.0;
	if(pos.x < -1.0) pos.x = -1.0;
	if(pos.y < -1.0) pos.y = -1.0;
	if(pos.z < -1.0) pos.z = -1.0;
	
	return pos;
}

//Phong shading .... siehe Paper (Capter 3)
vec3 phong(vec3 lightcolor, float distance, float kamb, float kdiff, float kspec, float n, float k1, float k2, vec3 norm, vec3 l, vec3 h)
{
	vec3 normal = normalize(norm);
	return	(lightcolor*kamb)+	(lightcolor/(k1+(k2*distance))*(kdiff*max(dot(normal, l),0.0)+	(kspec*pow(max(dot(normal, h),0.0),n))));
	//return norm;
}

float innerProduct(vec3 v1, vec3 v2) {

	return (v1.x * v2.x) + (v1.y * v2.y) + (v1.z * v2.z);
}

vec3 calcNormal(vec3 vec, bool preprocessing)
{
	vec3 norm2;
	
	//Partiellen Ableitungen berechne ("on the fly") oder lade (preprocessing)
	if(adaptiv == 0)	
	{
		vec4 norm3 = texture3D(sPartiel, vec);	//Preprocessing
		norm2.rgb = norm3.rgb;
		//normalize(norm2);
	}
	else{
		norm2 = vec3( 
					texture3D(volume_tex, vec.xyz+vec3(0.01,0.00,0.00)).r-texture3D(volume_tex, vec.xyz-vec3(0.01,0.00,0.00)).r,
					texture3D(volume_tex, vec.xyz+vec3(0.00,0.01,0.00)).r-texture3D(volume_tex, vec.xyz-vec3(0.00,0.01,0.00)).r,
					texture3D(volume_tex, vec.xyz+vec3(0.00,0.00,0.01)).r-texture3D(volume_tex, vec.xyz-vec3(0.00,0.00,0.01)).r
					);	//"on the fly"
		norm2*= 1.0/2.0;
	}
	
	return norm2;
}

vec3 cellshading(vec3 lightcolor, float distance, float kamb, float kdiff, float kspec, float n, float k1, float k2, vec3 norm, vec3 l, vec3 h,vec3 view, vec3 vec)
{
vec3 normal = normalize(norm);
    // Calculate diffuse light amount
    float intensity = max(dot(normal, l),0.0);
    if(intensity < 0)
        intensity = 0;
 
    // Calculate what would normally be the final color, including texturing and diffuse lighting
    vec3 color = lightcolor;
 
    // Discretize the intensity, based on a few cutoff points
    if (intensity > 0.95)
        lightcolor = vec3(1.0,1,1);
    else if (intensity > 0.5)
        lightcolor = vec3(0.7,0.7,0.7);
    else if (intensity > 0.05)
        lightcolor = vec3(0.5,0.5,0.5);
    else
        lightcolor = vec3(0.3,0.3,0.3);
        
    //vec3 norm3 = calcNormal(vec+vec3(0,0,0.001), preprocessing);
    float edgefactor = clamp(length(norm)*kdiff*max(dot(normal, l),0.0),0.0,1.0);
    if(edgefactor >= 0.05)	edgefactor = 1.0;
    else					edgefactor = 0.0;
	
	return	color*(1.0-pow(max(dot(normal, l),0.5),10.0));
}


//Main Methode
void main()
{ 
	if(IsMode == 1)
	{
		float stepsize = 1.0/200.0;						//Definiert die Schrittweite des Strahles
		float stepsize2 = 1.0/1000.0;						//Definiert die Schrittweite des Strahles
		vec3 bposition = position.xyz / position.w;		//Erzeugt Texturkoordinaten		
		
		vec3 back = texture2D(sBackFace, ((bposition.xy+1.0)/2.0).st).xyz;
		vec3 start = hposition.xyz;
	
		//FRONT TO BACK
		//vec3 direction = back - start;					//Direction vom Strahl
		//vec3 vec = start;
		
		//BACK TO FRONT
		vec3 direction = start-back;					//Direction vom Strahl
		vec3 vec = back;
		
		float len = length(direction);					//Lnge vom Strahl
		vec3 norm_dir = normalize(direction);			//Directionvektor normalisieren

		vec3 delta_dir = direction * stepsize;			
		float delta_dir_len = length(delta_dir);
		
		float alpha_acc = 0.0;
		vec4 color_sample;
		float alpha_sample = 0.0;
		float length_acc = 0.0;
		vec4 col_acc = vec4(0,0,0,0);
		
		vec3 viewingdirection = normalize(back - start);
	
		vec3 lpos = vec3(0.0,0.0,3.5);
		
		/*	
			vec4 v1 = vec4( 0.0, 0.0, 0.0, 1.0);
			vec4 v2 = vec4( 0.0, 1.0, 0.0, 1.0);
			vec4 v3 = vec4( 1.0, 1.0, 0.0, 1.0);
			v1 = sAdaptivPlane * v1;
			v2 = sAdaptivPlane * v2;
			v3 = sAdaptivPlane * v3;
			
			vec3 aux1 = v1.xyz - v2.xyz;
			vec3 aux2 = v3.xyz - v2.xyz;

			vec3 normal = cross(aux2, aux1);
			normal = normalize(normal);
			
			float d = -1.0 * innerProduct(normal,v1.xyz);
		*/
		
		vec4 trans = vec4(0,0,0,0);
		
		for(int i = 0; i < 200 && (length_acc <= len);i++)
		{
			vec3 norm2 = calcNormal(vec, preprocessing);
			
			vec4 transfer;
			float lumin	= 0.0f;	
			
			
			//if ( (d + dot(normal.xyz,vec.xyz)) < 0.0)
			//{
				//lumin = texture3D(volume_tex, vec).r;						//3D Texture.... bei jeden Schritt auswerten bei Strahlposition (Transparenzwert)
				lumin = texture3D(sPartiel, vec).a;						//3D Texture.... bei jeden Schritt auswerten bei Strahlposition (Transparenzwert)
			//}																											//If for slicing...
			
			//transfer = length(norm2) * texture1D(sTransfer, lumin);	//Transferfunktion	(Farbwert)		
			transfer = texture1D(sTransfer, lumin);	//Transferfunktion	(Farbwert)		
			vec4 color_sample = transfer;
			
			alpha_sample = transfer.a;		
			
			
			if(sPreshading == 0) 
			{
				vec3 l =  lpos - vec;// light vector
				vec3 h = normalize(norm_dir + l); // half vector  
				
				color_sample = vec4(cellshading(color_sample.xyz, length(vec), 0.01, 0.5, 0.8, 1.0, 0.3, 0.1, norm2, normalize(l), h,viewingdirection,vec),1.0); 
				//color_sample = vec4(phong(color_sample.xyz, length(vec), 0.01, 0.5, 0.8, 1.0, 0.3, 0.1, norm2, normalize(l), h),1.0); 
				//color_sample = vec4(norm2.x, norm2.y, norm2.z, 1.0f).abgr;
			}
			
			if(sMaxIntensity == 1)
			{
				/*
				//MIP
				if(alpha_sample > alpha_acc)
				{
					col_acc   = color_sample;
					alpha_acc = alpha_sample;
				}
				
				//AVERAGE
				col_acc   += color_sample*alpha_sample;
				alpha_acc = 1;	
				*/
				
				/*
				//FRONT TO BACK
				//CONTOUR
				col_acc   += (1.0-alpha_acc) * (length(norm2) * pow(1.0 - dot(norm2, norm_dir),2)) * color_sample * alpha_sample;
				//col_acc   += (length(norm2) * pow(1.0 - dot(norm2, norm_dir),2)) * color_sample;
				alpha_acc += (1.0-alpha_acc)*alpha_sample;
				*/
				
				//BACK TO FRONT
				//CONTOUR
				
				/*
				alpha_sample = length(texture1D(sTransfer, length(norm2))) *  pow(1.0 - abs(dot(normalize(norm2), norm_dir*-1.0)),20.0);
				color_sample   = ((1.0-alpha_sample) * col_acc) + (alpha_sample *color_sample); //oder halt transfer anstatt von color_sample
				
				//And now MIP
				if(alpha_sample > alpha_acc)
				{
					col_acc   = color_sample;
					alpha_acc = alpha_sample;
				}*/
				
				alpha_sample = length(texture1D(sTransfer, length(norm2))) *  pow(1.0 - abs(max(dot(normalize(norm2), viewingdirection),-0.5)),10.0);
				col_acc   = ((1.0-alpha_sample) * col_acc) + (alpha_sample *color_sample);				
			}
			else	
			{	
				/*
				//FRONT TO BACK			
				col_acc   += (1.0-alpha_acc) * color_sample * alpha_sample;
				alpha_acc += (1.0-alpha_acc)*alpha_sample;	
				*/
				
				//BACK TO FRONT
				col_acc   = ((1.0-alpha_sample) * col_acc) + (alpha_sample *color_sample);
				alpha_acc = alpha_sample;
			}
			/*
			if(adaptiv == 1)
		    {
				//delta_dir = norm_dir * ((stepsize * (1.0-transfer.a)) + (stepsize2 * transfer.a));
				delta_dir = norm_dir * ((stepsize * (1.0-lumin)) + (stepsize2 * lumin));
				delta_dir_len = length(delta_dir);
			}
			*/
			vec += delta_dir;
			length_acc += delta_dir_len;
		}
   
		gl_FragColor = vec4(col_acc.xyz,alpha_acc);
		//if(sMaxIntensity == 1) gl_FragColor = col_acc/col_acc.a;
	}
	else
	{
		vec3 bposition = position.xyz / position.w;		//Erzeugt Texturkoordinaten
		vec3 tex;
		if(IsMode == 2)	tex = vec3( ((bposition.xy+1.0)/2.0).x,sSlideValue,((bposition.xy+1.0)/2.0).y);
		if(IsMode == 3)	tex = vec3( sSlideValue,((bposition.xy+1.0)/2.0).xy);
		if(IsMode == 4)	tex = vec3( ((bposition.xy+1.0)/2.0).xy,sSlideValue);
		
		//gl_FragColor = texture1D(sTransfer, texture3D(volume_tex, tex).r);
		gl_FragColor = texture1D(sTransfer, texture3D(sPartiel, tex).a);
		//gl_FragColor /= gl_FragColor.w;
	}
}