//uniform... von OpenGL...
uniform sampler1D sTransfer;
uniform sampler1D sCartoon;
uniform sampler2D sBackFace;
uniform sampler3D volume_tex;
uniform sampler3D sPartiel;
uniform vec3 sSliding;
uniform int IsMode;
uniform float sSlideValue;
uniform int adaptiv;
uniform int sMaxIntensity;
uniform int sPreshading;

//varying... von Vertex Shader
varying vec4 hposition;
varying vec4 position;
varying mat4 sAdaptivPlane;

vec3 resolution = vec3(1.0/128.0, 1.0/128.0, 1.0/128.0);

//globlae variable
bool preprocessing = false; //Preprocessing wohl ned ganz ok?

vec3 readTexture(vec3 pos)
{
	if(pos.x > 1.0) pos.x = 1.0;
	if(pos.y > 1.0) pos.y = 1.0;
	if(pos.z > 1.0) pos.z = 1.0;
	if(pos.x < -1.0) pos.x = -1.0;
	if(pos.y < -1.0) pos.y = -1.0;
	if(pos.z < -1.0) pos.z = -1.0;
	
	return pos;
}

//Phong shading .... siehe Paper (Capter 3)
vec3 phong(vec3 lightcolor, float distance, float kamb, float kdiff, float kspec, float n, float k1, float k2, vec3 norm, vec3 l, vec3 h)
{
	vec3 normal = normalize(norm);
	return	(lightcolor*kamb)+	(lightcolor/(k1+(k2*distance))*(kdiff*min(1.0,max(dot(normal, l),0.0))+	(kspec*min(1.0,pow(max(dot(normal, h),0.0),n)))));
	//return norm;
}

vec3 fressnel(vec3 lightcolor, float distance, float kamb, float kdiff, float kspec, float n, float k1, float k2, vec3 Normal, vec3 l, vec3 h, vec3 View,vec3 vec)
{
	 // fetch from the incoming normal map:
   vec3 vNormal = normalize(Normal);

   // Scale and bias fetched normal to move into [-1.0, 1.0] range:
   vNormal = 2.0 * vNormal - 1.0;

   // The view vector (which is currently in world space) needs to be normalized.
   // This vector is normalized in the pixel shader to ensure higher precision of
   // the resultinv view vector. For this highly detailed visual effect normalizing
   // the view vector in the vertex shader and simply interpolating it is insufficient
   // and produces artifacts.
   vec3 vView =  normalize( View );

   // Transform the surface normal into world space (in order to compute reflection vector to perform environment map look-up):
   mat3 mTangentToWorld;
    
   vec3 tangent = vec3( texture3D(sPartiel, vec.xyz+vec3(0.02,0.00,0.00)).a-texture3D(sPartiel, vec.xyz-vec3(0.02,0.00,0.00)).a);
   vec3 tangent2 = vec3( texture3D(sPartiel, vec.xyz+vec3(0.00,0.00,0.02)).a-texture3D(sPartiel, vec.xyz-vec3(0.00,0.00,0.02)).a);
						
	tangent = normalize(tangent);
	tangent2 = normalize(tangent2);
						
   mTangentToWorld[0] = tangent;
   mTangentToWorld[1] = tangent2;
   mTangentToWorld[2] = cross(tangent,tangent2);   
   vec3   vNormalWorld    = normalize( mTangentToWorld * vNormal );

   // Compute reflection vector resulted from the clear coat of paint on the metallic surface:
   float  fFresnel = clamp(dot( vNormalWorld, vView), 0.0, 1.0);

   // Compute final paint color: combines all layers of paint as well as two layers of microflakes
   float  fFresnelSq = fFresnel * fFresnel;
   vec4 paintColor = fFresnel   * vec4(lightcolor,1.0) + fFresnelSq * vec4(1,0.5,0.5,1.0) + fFresnelSq * fFresnelSq * vec4(1,0,0,1); 
            
	return	paintColor.xyz;
	//return norm;
}

float innerProduct(vec3 v1, vec3 v2) {

	return (v1.x * v2.x) + (v1.y * v2.y) + (v1.z * v2.z);
}

vec3 calcNormal(vec3 vec, bool preprocessing)
{
	vec3 norm2;
	
	//Partiellen Ableitungen berechne ("on the fly") oder lade (preprocessing)
	if(adaptiv == 0)	
	{
		vec4 norm3 = texture3D(sPartiel, vec);	//Preprocessing
		norm2.rgb = norm3.rgb;
		//normalize(norm2);
	}
	else{
		norm2 = vec3( 
					texture3D(sPartiel, vec.xyz+vec3(resolution.x,0.00,0.00)).a-texture3D(sPartiel, vec.xyz-vec3(resolution.x,0.00,0.00)).a,
					texture3D(sPartiel, vec.xyz+vec3(0.00,resolution.y,0.00)).a-texture3D(sPartiel, vec.xyz-vec3(0.00,resolution.y,0.00)).a,
					texture3D(sPartiel, vec.xyz+vec3(0.00,0.00,resolution.z)).a-texture3D(sPartiel, vec.xyz-vec3(0.00,0.00,resolution.z)).a
					);	//"on the fly" keine Ahnung was schner ist
	}
	
	return norm2;
}

//Main Methode
void main()
{ 
		float stepsize = 1.0/500.0;						//Definiert die Schrittweite des Strahles
		float stepsize2 = 1.0/1000.0;						//Definiert die Schrittweite des Strahles
		vec3 bposition = position.xyz / position.w;		//Erzeugt Texturkoordinaten		
		
		vec3 back = texture2D(sBackFace, ((bposition.xy+1.0)/2.0).st).xyz;
		vec3 start = hposition.xyz;
	
		//FRONT TO BACK
		vec3 direction = back - start;					//Direction vom Strahl
		vec3 vec = start;
		
		//BACK TO FRONT
		//vec3 direction = start-back;					//Direction vom Strahl
		//vec3 vec = back;
		
		float len = length(direction);					//Lnge vom Strahl
		vec3 norm_dir = normalize(direction);			//Directionvektor normalisieren

		vec3 delta_dir = direction * stepsize;			
		float delta_dir_len = length(delta_dir);
		
		float alpha_acc = 0.0;
		vec4 color_sample;
		float alpha_sample = 0.0;
		float length_acc = 0.0;
		vec4 col_acc = vec4(0,0,0,0);
		
		vec3 viewingdirection = normalize(back - start);
	
		vec3 lpos = vec3(0.0,0.0,1.0);		
		vec4 trans = vec4(0,0,0,0);
		
		for(int i = 0; i < 500 && (length_acc <= len);i++)
		{
			vec3 norm2 = calcNormal(vec, preprocessing);			
			float lumin	= 0.0f;				
			
			float sval = texture3D(sPartiel, vec).a;
			
			
			vec4 a1 = (0.125*texture3D(sPartiel, vec.xyz+vec3(resolution.x,0.00,0.00)))
			         +(0.125*texture3D(sPartiel, vec.xyz-vec3(resolution.x,0.00,0.00)))
			         +(0.125*texture3D(sPartiel, vec.xyz+vec3(0.00,0.00,resolution.z)))
					 +(0.125*texture3D(sPartiel, vec.xyz-vec3(0.00,0.00,resolution.z)))
					 +(0.125*texture3D(sPartiel, vec.xyz+vec3(resolution.x,0.00,resolution.z)))
					 +(0.125*texture3D(sPartiel, vec.xyz-vec3(resolution.x,0.00,resolution.z)))
					 +(0.125*texture3D(sPartiel, vec.xyz+vec3(-resolution.x,0.00,resolution.z)))
					 +(0.125*texture3D(sPartiel, vec.xyz-vec3(-resolution.x,0.00,resolution.z)));
			
			sval = (a1.a * 0.5)+(sval*0.5);
			norm2 = (norm2.xyz * 0.5)+(a1.xyz*0.5);
			
			vec4 transfer = texture1D(sTransfer, sval);
			alpha_sample = transfer.a;	
			
			vec4 color_sample = transfer;
			vec3 l =  lpos - vec;// light vector
			vec3 h = normalize(norm_dir + l); // half vector  		
			
			if(sPreshading == 0) 
			{		
				color_sample = vec4(fressnel(color_sample.xyz, length(vec), 0.01, 0.5, 0.8, 1.0, 0.3, 0.1, norm2, normalize(l), h,viewingdirection,vec),1.0); 
			}
			else
			{
				color_sample = vec4(phong(color_sample.xyz, length(vec), 0.01, 0.5, 0.8, 1.0, 0.3, 0.1, norm2, normalize(l), h),1.0); 
			}
   
			
			if(sMaxIntensity == 1)
			{				
				//MIP
				if(alpha_sample > 0.05)
				{
					col_acc   = color_sample;
					alpha_acc = alpha_sample;
					break;
				}
			}
			else	
			{	
				//FRONT TO BACK		
				col_acc   += (1.0-alpha_acc) * color_sample * alpha_sample;
				alpha_acc += (1.0-alpha_acc)*alpha_sample;	
			}
		
			vec += delta_dir;
			length_acc += delta_dir_len;
		}
		
		
		
		gl_FragColor = col_acc;
}