 uniform sampler2D Texture;
 uniform vec2 lightPos;
 uniform float weight;
 uniform float exposure;
 uniform float density;
 uniform float decay;
 const int numofsamples = 75;

 void main()
 {
	vec2 texCoordinate = gl_TexCoord[0].st;
	vec2 deltaTextCoordinate = vec2( texCoordinate - lightPos.xy );
	deltaTextCoordinate *= density /  numofsamples;
	float illuDecay = 1.0;

	for(int i=0; i < numofsamples; i++)
	{
		texCoordinate -= deltaTextCoordinate;
		vec4 sample = texture2D(Texture, texCoordinate);
			
		sample *= illuDecay * weight;
		illuDecay *= decay;

		gl_FragColor += sample;
	}

	gl_FragColor *= exposure;
}